//Sniper_Rifle.cs

//audio
datablock AudioProfile(Sniper_RifleShot1Sound)
{
   filename    = "./ScatterGun_Fire.wav";
   description = AudioClose3d;
   preload = true;
};

//audio
datablock AudioProfile(Sniper_RifleReload1Sound)
{
   filename    = "./Pump_ShotGun_Reload.wav";
   description = AudioClose3d;
   preload = true;
};

//shell
datablock DebrisData(Sniper_RifleShellDebris)
{
	shapeFile = "./shotgunShell.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};

datablock ParticleData(Sniper_RifleExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = 1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 400;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.9 0.9 0.9 0.3";
	colors[1]     = "0.9 0.5 0.6 0.0";
	sizes[0]      = 0.25;
	sizes[1]      = 0.75;

	useInvAlpha = true;
};
datablock ParticleEmitterData(Sniper_RifleExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 2;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Sniper_RifleExplosionParticle";

   useEmitterColors = true;
   uiName = "Sniper Hit Dust";
};


datablock ParticleData(Sniper_RifleExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 50;
	lifetimeVarianceMS   = 35;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1 1 0.0 0.9";
	colors[1]     = "0.9 0.0 0.0 0.0";
	sizes[0]      = 1;
	sizes[1]      = 0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(Sniper_RifleExplosionRingEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "Sniper_RifleExplosionRingParticle";

   useEmitterColors = true;
   uiName = "Sniper_Rifle Hit Flash";
};

datablock ExplosionData(Sniper_RifleExplosion)
{
   //explosionShape = "";
	soundProfile = bulletHitSound;

   lifeTimeMS = 150;

   particleEmitter = Sniper_RifleExplosionEmitter;
   particleDensity = 5;
   particleRadius = 0.2;

   emitter[0] = Sniper_RifleExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 2;
   lightStartColor = "0.3 0.6 0.7";
   lightEndColor = "0 0 0";
};


AddDamageType("Sniper_Rifle",   '<bitmap:add-ons/Weapon_SniperRifleB/CI_Sniper_Rifle> %1',    '%2 <bitmap:add-ons/Weapon_SniperRifleB/CI_Sniper_Rifle> %1',0.2,1);
datablock ProjectileData(Sniper_RifleProjectile)
{
   projectileShapeName = "./bullet.dts";
   directDamage        = 75;
   directDamageType    = $DamageType::Sniper_Rifle;
   radiusDamageType    = $DamageType::Sniper_Rifle;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 400;
   verticalImpulse	  = 400;
   explosion           = Sniper_RifleExplosion;
   particleEmitter     = ""; //bulletTrailEmitter;

   muzzleVelocity      = 180;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "";
};


//////////
// item //
//////////
datablock ItemData(Sniper_RifleItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Sniper2.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Sniper";
	iconName = "./icon_Sniper_Rifle";
	doColorShift = true;
	colorShiftColor = "1 1 1 1.000";

	 // Dynamic properties defined by the scripts
	image = Sniper_RifleImage;
	canDrop = true;
	
	maxAmmo = 1;
	canReload = 1;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(Sniper_RifleImage)
{
   // Basic Item properties
   shapeFile = "./Sniper2.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = Sniper_RifleItem;
   ammo = " ";
   projectile = Sniper_RifleProjectile;
   projectileType = Projectile;

	casing = Sniper_RifleShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = Sniper_RifleItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                    			= "Activate";
	stateTimeoutValue[0]            			= 0.15;
	stateSequence[0]			  	= "Activate";
	stateTransitionOnTimeout[0]     		= "Wait";
	stateSound[0]			  	= weaponSwitchSound;

	stateName[1]                    			= "Ready";
	stateTransitionOnTriggerDown[1] 		= "Fire";
	stateTransitionOnNoAmmo[1]		= "ReloadCheckA";
	stateAllowImageChange[1]			= true;
	stateSequence[1]			  	= "ready";

	stateName[2]                    			= "Fire";
	stateTransitionOnTimeout[2]     		= "Smoke";
	stateTimeoutValue[2]            			= 0.1;
	stateFire[2]                    			= true;
	stateAllowImageChange[2]        		= false;
	stateScript[2]                  			= "onFire";
	stateWaitForTimeout[2]		  	= true;
	stateEmitter[2]			  	= gunFlashEmitter;
	stateEmitterTime[2]		  	= 0.05;
	stateEmitterNode[2]		  	= "muzzleNode";
	stateSound[2]			  	= Sniper_RifleShot1Sound;

	stateName[3] 			  	= "Smoke";
	stateEmitter[3]			  	= gunSmokeEmitter;
	stateEmitterTime[3]		  	= 0.1;
	stateEmitterNode[3]		  	= "muzzleNode";
	stateTimeoutValue[3]            			= 0.2;
	stateTransitionOnTimeout[3]     		= "LoadCheckA";
	stateEjectShell[3]       	  		= true;
	
	stateName[4]				= "LoadCheckA";
	stateScript[4]				= "onLoadCheck";
	stateTimeoutValue[4]			= 0.01;
	stateTransitionOnTimeout[4]			= "LoadCheckB";
						
	stateName[5]				= "LoadCheckB";
	stateTransitionOnAmmo[5]			= "Ready";
	stateTransitionOnNoAmmo[5]		= "ForceReload";
	
	stateName[6]				= "ReloadCheckA";
	stateScript[6]				= "onReloadCheck";
	stateTimeoutValue[6]			= 0.01;
	stateTransitionOnTimeout[6]			= "ReloadCheckB";
						
	stateName[7]				= "ReloadCheckB";
	stateTransitionOnAmmo[7]			= "CompleteReload";
	stateTransitionOnNoAmmo[7]		= "Reload";
						
	stateName[9]				= "ForceReload";
	stateTransitionOnTimeout[9]     		= "ForceReloaded";
	stateTimeoutValue[9]			= 0.35;
	stateSequence[9]				= "Reload";
	stateSound[9]				= Block_MoveBrick_Sound;
	stateScript[9]				= "onReloadStart";
	
	stateName[10]				= "ForceReloaded";
	stateTransitionOnTimeout[10]     		= "ReloadCheckA";
	stateTimeoutValue[10]			= 0.2;
	stateScript[10]				= "onReloaded";
	
	stateName[11]				= "Reload";
	stateTransitionOnTimeout[11]     		= "Reloaded";
	stateTransitionOnTriggerDown[11]		= "Fire";
	stateWaitForTimeout[11]			= false;
	stateTimeoutValue[11]			= 0.35;
	stateSequence[11]				= "Reload";
	stateSound[11]				= Block_MoveBrick_Sound;
	stateScript[11]				= "onReloadStart";
	
	stateName[12]				= "Reloaded";
	stateTransitionOnTimeout[12]     		= "ReloadCheckA";
	stateTransitionOnTriggerDown[12]		= "Fire";
	stateWaitForTimeout[12]			= false;
	stateTimeoutValue[12]			= 0.2;
	stateScript[12]				= "onReloaded";

	stateName[13]			  	= "CompleteReload";
	stateTimeoutValue[13]		  	= 0.5;
	stateTransitionOnTimeout[13]	  	= "Ready";
	stateWaitForTimeout[13]		  	= true;
	stateSequence[13]			  	= "fire";
	stateSound[13]			  	= Sniper_RifleReload1Sound;
	stateScript[13]                  			= "onEject";

	stateName[8]				= "Wait";
	stateTransitionOnTimeout[8]		= "LoadCheckA";
	stateTimeoutValue[8]			= 0.6;

};

function Sniper_RifleImage::onReloadStart(%this,%obj,%slot)
{
	%obj.playThread(2, shiftRight);
}

function Sniper_RifleImage::onEject(%this,%obj,%slot)
{
	%obj.playThread(2, plant);
}

//function Sniper_RifleImage::onReloaded(%this,%obj,%slot)
//{
//	%obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
//	%obj.setImageAmmo(%slot,1);
//}

function Sniper_RifleImage::onFire(%this,%obj,%slot)
{
	%obj.playThread(2, plant);
	
	if(%obj.iscrouched())
	{
		if(vectorlen(%obj.getvelocity()) > 0)
		{
			%speed  = vectorLen(%obj.getvelocity());
			%spread = %speed / 6000;
			%gain  = 25;
			%base  = 40;
		}
	
		else
		{
			%spread = 0;
			%gain = 35;
			%base = 60;
		}
	

	}
	
	else if(vectorlen(%obj.getvelocity()) > 0)
	{

	%speed  = vectorLen(%obj.getvelocity());
	%spread = %speed / 4000 + 0.00150;
	%gain = 1;
	%base = 30;
	
	}
	
	else
	{
	
	%spread = 0.00025;
	%gain = 25;
	%base = 40;

	}
	
	%projectile = %this.projectile;
	%obj.toolAmmo[%obj.currTool]--;
	
	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
	%velocity = MatrixMulVector(%mat, %velocity);
	
	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
		spawntime = getsimtime();
		gain = %gain;
		base = %base;
	};
	MissionCleanup.add(%p);	
}


function Sniper_RifleProjectile::Damage(%this,%obj,%col,%fade,%pos,%norm)
{
      	%damageType = %this.DirectDamageType;
	%obj.deathtime = getsimtime();
	%damage = %obj.base + ((%obj.deathtime - %obj.spawntime) / 1000 * %obj.gain);

  	%sobj = %obj.sourceObject;
   
   	if(%col.getType() & $TypeMasks::PlayerObjectType)
   	{
      		%colscale = getWord(%col.getScale(),2);
      		if(getword(%pos, 2) > getword(%col.getWorldBoxCenter(), 2) - 3.3*%colscale)
      		{

         			%damage = (%obj.base + 10) + ((%obj.deathtime - %obj.spawntime) / 1000 * 100);
         			
         			if(isObject(%col.client))
            			%col.client.centerprint("\c6 You got head shoted!",2);
         
         			if(%sobj.getType() & $TypeMasks::PlayerObjectType)
         			{
            				serverplay3d(critFireSound,%sobj.getHackPosition());
            				if(isObject(%sobj.client))
               				%sobj.client.play2D(rewardSound);
				%sobj.client.centerprint("\c6Head Shot!",2);
         			}
      		}
      
      	%col.damage(%obj, %pos, %Damage, %damageType);
   	}
   	else
   	{
      	%col.damage(%obj, %pos, %Damage, %damageType);
   	}
}

